/*
 * Tara Graeve
 * Assignment 6: Malicious Hangman
 * 11/15/19
 */

import java.util.Iterator;
import java.util.Map;
import java.util.Random;
import java.util.Set;
import java.util.TreeMap;
import java.util.TreeSet;

public class MaliciousHangman extends Hangman {
	private Set<String> dictionary = new TreeSet<>(); 

	public MaliciousHangman(Set<String> dictionary, int length, int guessCount) {
		super(length, guessCount);
		this.dictionary = new TreeSet<>();
		
		Iterator<String> it = dictionary.iterator();
		
		//add if the word is the given length 
		while(it.hasNext()) {
			String next = it.next(); 
			if(next.length() == length) {
				this.dictionary.add(next);
			}
		}
	}

	@Override
	protected boolean makeNewGuess(char c) {
		Map	<String,TreeSet<String>> words = new TreeMap<>(); 
		Iterator<String> iter = dictionary.iterator(); 
		 
		//getting the states of the words in the dictionary and adding to map 
		while(iter.hasNext()) {
			 String word = iter.next(); 
			 String wordState = getState(word,c); 
			 if(words.get(wordState) == null) {
				 words.put(wordState, new TreeSet<>()); 
			 }
			 words.get(wordState).add(word); 


		 }
		 
		//figure out which state has the most options and set that to the new dictionary
		// update state accordingly 
		 char[] newState = null; 
		 int max = 0; 
		 for(Map.Entry<String, TreeSet<String>> e: words.entrySet()) {
			 int size = e.getValue().size(); 
			 if(size > max) {
				 max = size; 
				 dictionary = e.getValue(); 
				 newState = e.getKey().toCharArray();  
			 }
			 
		 }
		 
		 // checking new state against state 
		 boolean ret = false; 
		 for(int i = 0; i < state.length; i++) {
			 if(newState[i] != state[i]) {
				 ret = true; 
				 break; 
			}
		 }
		 
		 state = newState; 
		 return ret; 
		
	}
	
	//helper method to get state 
	private String getState(String word, char c) {
		char[] state = this.state.clone(); 
		
		for(int i = 0; i < word.length(); ++i) {
			if(word.charAt(i) == c) {
				state[i] = c; 
			}
		}

		return new String(state);
	}

	@Override
	public String getWord() {
		Random rng = new Random(); 
		
		// pick a random place in the dictionary
		int index = rng.nextInt(dictionary.size()); 
		
		// keep track of index 
		int i = 0; 
		
		// return word at given index
		for(String d: dictionary) {  
			if(index == i) {
				return d; 
			}
			++i; 
		}
		return null; 
		
	}

}
